package com.bundt.price.domain;

import java.util.logging.Logger;
import java.util.logging.Level;

class BundtItem extends DomainObject implements Comparable<BundtItem>{
	private static final Logger logger
	static {
		logger = Logger.getLogger(BundtItem.class.getName())
	}

		String itemName = ""
	String itemType
	BigDecimal itemPrice = new BigDecimal("1.00")
	Double quantity = new Double(1.0)
	String unit
	Integer unitCount = new Integer(1)
	BigDecimal unitCost = new BigDecimal("0.00")
	String brand;
	Long vendorId = new Long(-1)
	String vendorName
	boolean batchItem = true
	String remark

	def setItemPrice(double price) {
		this.itemPrice = new BigDecimal(Double.toString(price))
		this.itemPrice.setScale(2)
	}
	
	def calculateCost(){
		logger.log(Level.INFO, "calculateCost")
		if (itemPrice){
			if(unit) {
				BigDecimal bgUnit = new BigDecimal(UnitConversion.getInstance().convertItemUnit(unit).toString())
				bgUnit.setScale(2, BigDecimal.ROUND_CEILING)
				logger.log(Level.INFO, "  Converted Unit = " + bgUnit.toString())
				BigDecimal bgUnitCount = bgUnit.multiply(new BigDecimal(quantity.toString()))
				logger.log(Level.INFO, "Price " + itemPrice + "\\ Unit Count = " + bgUnitCount.toString())
				unitCost = itemPrice.divide(bgUnitCount, 2, BigDecimal.ROUND_CEILING)
				
				logger.log(Level.INFO, "  Cost = " + unitCost.toString())
			}
		}
	}
		
    public int compareTo(BundtItem itm) {
        return itemName.compareTo(itm.getItemName());
    }
	
	def String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("\n").append(getItemName())
		sb.append("\n").append(getDbId())
		return sb.toString()
	}
}
